<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:MembershipRequest="fba:MembershipRequest">
<xsl:template match="/">
<html>
<head>
    <title>Passwort zurückgesetzt</title>
<style>
#outlook a { 
	padding:0; 
}
body {
	width:100% !important; 
	min-width: 100%;
	-webkit-text-size-adjust:100%; 
	-ms-text-size-adjust:100%; 
	margin:0;
	padding:0;
}
table {
	border-spacing: 0;
	border-collapse: collapse;
}
td {
	word-break: break-word;
	-webkit-hyphens: auto;
	-moz-hyphens: auto;
	hyphens: auto;
	border-collapse: collapse !important; 
}
table, tr, td {
	padding: 0;
	vertical-align: top;
	text-align: left;
}
.ExternalClass {
	width:100%;
	margin:0;
	padding:0;
} 
.ExternalClass, 
.ExternalClass p, 
.ExternalClass span, 
.ExternalClass font, 
.ExternalClass td, 
.ExternalClass div { 
	line-height: 100%; 
}
.spacer {
	width: 1px;
	height: 1px;
}
.content {
	width:540px;
	padding: 0 20px;
}
body, table.body, h1, h2, h3, h4, h5, h6, p, td {
	color: #222222;
	font-family: "Segoe UI", "Helvetica", "Arial", sans-serif; 
	font-weight: normal;
	padding:0; 
	margin: 0;
	text-align: left; 
	line-height: 1.8;
}
p {
	padding-bottom:5px;
}
a {
  color: #0072c6; 
  text-decoration: none;
}
a:hover { 
	color: #0092e6 !important;
}
a:active { 
	color: #0092e6 !important;
}
a:visited { 
	color: #0072c6 !important;
}
h1, h2, h3, h4, h5, h6 {
	font-family: "Segoe UI Light", "Segoe UI", "Helvetica", "Arial", sans-serif;
	line-height: 1.4;
	word-break: normal;
}
h1 {
	font-size: 40px;
	padding:0;
}
body, table.body, p, td {
	font-size: 15px;
	line-height:24px;
}
.headerrow {
	background: #0072c6;
	padding-top:20px;
	padding-bottom:20px;
	text-align:center;
}
.headertitle {
	color:#ffffff;
	padding:0;
	font-size: 28px;
}
.hellowrow {
	padding-top:40px;
	text-align:center;
}
.row {
	padding-top:20px;
	text-align:center;
}
.lead {
	font-size: 19px;
	line-height:27px;
}
.panel {
	background-color: #e7f5ff;
	border: 1px solid #bbe2ff;
	padding: 14px 15px 15px 20px;
}
.contentpanel {
	width:540px;
	padding: 0 20px;
}
</style>
</head>
<body>

<table border="0" cellspacing="0" cellpadding="0" width="100%">
	<tr>
		<td class="headerrow" align="center" valign="top">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
				<tr>
					<td><div class="spacer"></div></td>
					<td class="content" width="540"><h1 class="headertitle">Passwort zurückgesetzt</h1></td>
					<td><div class="spacer"></div></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="hellowrow" align="center" valign="top">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
				<tr>
					<td><div class="spacer"></div></td>
					<td class="content" width="540"><h1>Hi, <xsl:value-of select="MembershipRequest:get_FullName()" /></h1></td>
					<td><div class="spacer"></div></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="row" align="center" valign="top">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
				<tr>
					<td><div class="spacer"></div></td>
					<td class="content" width="540"><div class="lead">Ihr Passwort wurde zurückgesetzt um auf 
						<a>
		                    <xsl:attribute name="href">
		                        <xsl:value-of select="MembershipRequest:get_SiteURL()" />
		                    </xsl:attribute>
							<xsl:value-of select="MembershipRequest:get_SiteName()" />
						</a> zuzugreifen.</div></td>
					<td><div class="spacer"></div></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="row" align="center" valign="top">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
				<tr>
					<td><div class="spacer"></div></td>
					<td class="content" width="540">
						<table border="0" cellspacing="0" cellpadding="0" width="100%">
							<tr>
								<td class="panel">
									<p>Ihr Benutzername ist: <b><xsl:value-of select="MembershipRequest:get_UserName()" /></b></p>
									<p>Ihr neues Passwort ist: <b><xsl:value-of select="MembershipRequest:get_Password()" /></b></p>
								</td>
							</tr>
						</table>
					</td>
					<td><div class="spacer"></div></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="row" align="center" valign="top">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
				<tr>
					<td><div class="spacer"></div></td>
					<td class="content" width="540">
						Sie können Ihr neues Passwort ändern, indem Sie sich auf der 
						<a>
		                    <xsl:attribute name="href">
		                        <xsl:value-of select="MembershipRequest:get_ChangePasswordURL()" />
		                    </xsl:attribute>
							Passwort ändern Seite
						</a> 
						mit Ihrem Benutzernamen und dem neuen Passwort einloggen.
					</td>
					<td><div class="spacer"></div></td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="row" align="center" valign="top">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
				<tr>
					<td><div class="spacer"></div></td>
					<td class="content" width="540">
						Besten Dank<br/>
						<a href="http://www.getyournet.ch/">getYourNet IT Services</a>
					</td>
					<td><div class="spacer"></div></td>
				</tr>
			</table>
		</td>
	</tr>
</table>

</body>
</html>
</xsl:template>
</xsl:stylesheet>


